﻿
//www.HadiElectronic.com
using System;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;
using System.Text;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Diagnostics;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        SerialPort serialPort1 = new SerialPort();
        string SMSNum;
        bool SendFlag = false;
        bool SimStatusFlag = false;
        string indata = "";
        string ModuleType = "sim800c";

        #region Form1
        public Form1()
        {
            InitializeComponent();

            RichTextBox.CheckForIllegalCrossThreadCalls = false;
            foreach (string s in SerialPort.GetPortNames())
            {
                comboBoxPortList.Items.Add(s);
            }
            serialPort1.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);
            
        }
        #endregion

        #region buttonConnectToPort_Click
        private void buttonConnectToPort_Click(object sender, EventArgs e)
        {
            if (buttonConnectToPort.Text == "اتصال")
            {
                if (comboBoxPortList.Text != string.Empty)
                {
                    serialPort1.PortName = comboBoxPortList.Text;
                    serialPort1.BaudRate = 9600;

                    if (!serialPort1.IsOpen)
                        try
                        {
                            indata = "";
                            serialPort1.Open();
                            serialPort1.NewLine = "\r";

                            serialPort1.WriteLine("AT");
                            Thread.Sleep(200);

                            int t = 10000;
                            bool Connect = false;

                            while (t > 0)
                            {
                                Thread.Sleep(1);
                                if (indata.Contains("OK"))
                                {
                                    Connect = true;
                                    break;
                                }
                                t--;
                            }

                            if (Connect)
                            {

                                serialPort1.WriteLine("AT+GOI");
                                Thread.Sleep(500);

                                if (indata.Contains("R800"))
                                    ModuleType = "R800c";

                                buttonRefreshPorts.Enabled = false;
                                comboBoxPortList.Enabled = false;
                                buttonConnectToPort.Text = "قطع";
                                groupBoxSMS.Enabled = true;
                                groupBoxRecive.Enabled = true;
                                groupBoxStatus.Enabled = true;

                                serialPort1.WriteLine("AT+CMGD=1,4"); // Delete All SMS from SIM
                                Thread.Sleep(500);

                                //Enable Recive SMS
                                serialPort1.WriteLine("AT+CNMI=2,1,0,1,0");
                                Thread.Sleep(150);

                                //Sim Status - وضعیت سیمکارت
                                labelSimStatus.ForeColor = Color.Green;
                                labelSimStatus.Text = "متصل";
                                SimStatusFlag = true;
                                serialPort1.WriteLine("AT+CIMI");
                                Thread.Sleep(150);


                                //Anten Status - وضعیت آنتن
                                serialPort1.WriteLine("AT+CSQ");
                                Thread.Sleep(150);

                                //Network Status - وضعیت شبکه
                                serialPort1.WriteLine("AT+CREG?");
                                Thread.Sleep(150);

                                timer1.Enabled = true;
                            }
                            else
                            {
                                MessageBox.Show("اتصال بر قرار نشد");
                                if (serialPort1.IsOpen)
                                    serialPort1.Close();
                                indata = "";
                            }
                        }
                        catch
                        {
                            MessageBox.Show("اتصال بر قرار نشد");
                        }
                }
                else
                {
                    MessageBox.Show("لطفاً پورت مورد نظر را انتخاب فرمایید");
                    comboBoxPortList.Select();
                }
            }
            else
            {
                serialPort1.Close();
                indata = "";
                comboBoxPortList.Enabled = true;
                buttonConnectToPort.Text = "اتصال";
                groupBoxSMS.Enabled = false;
                groupBoxRecive.Enabled = false;
                groupBoxStatus.Enabled = false;

                labelSimStatus.Text = "";
                labelAntenStatus.Text = "";
                labelNetworkStatus.Text = "";
                buttonRefreshPorts.Enabled = true;

                timer1.Enabled = false;
            }
        }
        #endregion

        #region buttonSend_Click
        private void buttonSend_Click(object sender, EventArgs e)
        {
            if (Validation())
            {
                this.Cursor = Cursors.WaitCursor;
                SendFlag = true;
                SendSMSFunction(textBoxPhone.Text, richTextBoxMSG.Text);
                this.Cursor = Cursors.Default;
            }
        }
        #endregion

        #region Validation
        private bool Validation()
        {
            if (textBoxPhone.Text.Trim() == string.Empty)
            {
                MessageBox.Show("لطفا شماره موبایل را وارد نمایید", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error);
                textBoxPhone.Select();
                return false;
            }

            if (textBoxPhone.Text.Trim().Length != 13)
            {
                MessageBox.Show("شماره وارد شده صحیح نمی باشد", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error);
                textBoxPhone.Select();
                return false;
            }

            if (richTextBoxMSG.Text.Trim() == string.Empty)
            {
                if (MessageBox.Show("متن پیامک خالی می باشد.آیا ارسال شود؟", "هشدر", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.No)
                {
                    richTextBoxMSG.Select();
                    return false;
                }
            }

            return true;
        }
        #endregion

        #region SendSMSFunction
        private void SendSMSFunction(string PhoneNo, string Message)
        {

            serialPort1.WriteLine("AT+CMGF=1");
            Thread.Sleep(100);

            //Text Mode - ارسال بصورت اسکی
            //serialPort1.WriteLine("AT+CSCS=\"GSM\"");
            //Thread.Sleep(300);
            //serialPort1.WriteLine("AT+CSMP=17,167,0,0");
            //Thread.Sleep(300);

            //Unicode Mode - ارسال به صورت یونیکد
            serialPort1.WriteLine("AT+CSCS=\"HEX\"");
            Thread.Sleep(100);
            serialPort1.WriteLine("AT+CSMP=17,167,0,8");
            Thread.Sleep(100);

            if (ModuleType == "sim800c")
            {
                serialPort1.WriteLine("AT+CMGS=\"" + PhoneNo + "\"");
                Thread.Sleep(100);
            }
            else
            {
                string p = StringToHex2(PhoneNo);
                serialPort1.WriteLine("AT+CMGS=\"" + p + "\"");
                Thread.Sleep(100);
            }
            serialPort1.Write(StringToHex(Message) + '\x001a');
        }
        #endregion

        #region StringToHex
        private string StringToHex(string hexstring)
        {
            StringBuilder sb = new StringBuilder();
            foreach (char t in hexstring)
            {
                if (Convert.ToInt32(t).ToString("X").Length == 1)
                    sb.Append("000" + Convert.ToInt32(t).ToString("X"));
                if (Convert.ToInt32(t).ToString("X").Length == 2)
                    sb.Append("00" + Convert.ToInt32(t).ToString("X"));
                if (Convert.ToInt32(t).ToString("X").Length == 3)
                    sb.Append("0" + Convert.ToInt32(t).ToString("X"));
            }
            return sb.ToString();
        }
        #endregion

        #region StringToHex2
        private string StringToHex2(string hexstring)
        {
            StringBuilder sb = new StringBuilder();
            foreach (char t in hexstring)
            {
                if (Convert.ToInt32(t).ToString("X").Length == 1)
                    sb.Append("000" + Convert.ToInt32(t).ToString("X"));
                if (Convert.ToInt32(t).ToString("X").Length == 2)
                    sb.Append(Convert.ToInt32(t).ToString("X"));
                if (Convert.ToInt32(t).ToString("X").Length == 3)
                    sb.Append("0" + Convert.ToInt32(t).ToString("X"));
            }
            return sb.ToString();
        }
        #endregion

        #region DataReceivedHandler
        private void DataReceivedHandler(object sender,SerialDataReceivedEventArgs e)
        {
            try
            {
                SerialPort sp = (SerialPort)sender;
                indata = sp.ReadExisting();

                if (indata.Contains("+CMGS:"))
                {
                    label2.ForeColor = Color.Green;
                    label2.Text = "ارسال شد";
                    SendFlag = false;
                }
                else if (indata.Contains("ERROR") && SendFlag)
                {
                    label2.ForeColor = Color.Red;
                    label2.Text = "ارسال نشد";
                    SendFlag = false;
                }
                else if (indata.Contains("+CMTI:")) //دریافت پیامک مرحله اول
                {
                    indata = indata.Replace("\r\n", "");
                    string[] c = indata.Split(',');
                    SMSNum = c[1];

                    serialPort1.WriteLine("AT+CMGF=1");
                    Thread.Sleep(150);
                    serialPort1.WriteLine("AT+CSCS=\"UCS2\"");
                    Thread.Sleep(150);
                    serialPort1.WriteLine("AT+CSMP=17,167,0,0");
                    Thread.Sleep(150);
                    //serialPort1.WriteLine("AT+CMGR=" + SMSNum + ",1");
                    serialPort1.WriteLine("AT+CMGR=" + SMSNum);
                    Thread.Sleep(2000);
                }
                else if (indata.Contains("+CMGR:"))// دریافت پیامک مرحله دوم
                {
                    string temp = indata.Substring(indata.IndexOf("+CMGR:"));
                    string[] RData = temp.Split(',');
                    string Phone = RData[1].Replace("\"", "");
                    StringBuilder sb = new StringBuilder();
                    for (int j = 0; j < Phone.Length; j += 4)
                        sb.AppendFormat("\\u{0:x4}", Phone.Substring(j, 4));
                    Phone = System.Text.RegularExpressions.Regex.Unescape(sb.ToString());
                    Phone = "0" + Phone.Substring(3);

                    temp = RData[4].Substring(RData[4].IndexOf("\r\n") + 2);
                    temp = temp.Remove(temp.IndexOf("\r\n"));
                    sb.Remove(0, sb.Length);
                    for (int j = 0; j < temp.Length; j += 4)
                        sb.AppendFormat("\\u{0:x4}", temp.Substring(j, 4));
                    string Msg = System.Text.RegularExpressions.Regex.Unescape(sb.ToString());

                    try
                    {
                        dataGridViewRecivedSMS.Rows.Add();
                        dataGridViewRecivedSMS[0, dataGridViewRecivedSMS.Rows.Count - 1].Value = DateTime.Now;
                        dataGridViewRecivedSMS[1, dataGridViewRecivedSMS.Rows.Count - 1].Value = Phone;
                        dataGridViewRecivedSMS[2, dataGridViewRecivedSMS.Rows.Count - 1].Value = Msg;
                        dataGridViewRecivedSMS.Sort(dataGridViewRecivedSMS.Columns[0], System.ComponentModel.ListSortDirection.Descending);
                    }
                    catch (Exception exp)
                    {

                    }
                    serialPort1.WriteLine("AT+CMGD=" + SMSNum); // Delete SMS from SIM
                    Thread.Sleep(150);
                }
                else if (indata.Contains("+CSQ:")) //درصد آنتن
                {
                    int p = Convert.ToInt32(Regex.Match(indata, @"\d+").ToString());
                    p = (p * 827) + 127;
                    p = p >> 8;
                    p = (p > 100) ? 100 : p;
                    labelAntenStatus.Text = p.ToString() + "%";
                }
                else if (indata.Contains("+CREG:"))//وضعیت شبکه
                {
                    string[] RData = indata.Substring(indata.IndexOf("+CREG:") + 6).Split(',');
                    switch (int.Parse(RData[1].Substring(0, 1)))
                    {
                        case 0:
                            labelNetworkStatus.Text = "Not registered, Not searching";
                            break;
                        case 1:
                            labelNetworkStatus.Text = "Registered, home network";
                            break;
                        case 2:
                            labelNetworkStatus.Text = "Not registered, searching...";
                            break;
                        case 3:
                            labelNetworkStatus.Text = "Registration denied";
                            break;
                        case 4:
                            labelNetworkStatus.Text = "Unknown";
                            break;
                        case 5:
                            labelNetworkStatus.Text = "Registered, roaming";
                            break;
                        default:
                            labelNetworkStatus.Text = indata.Substring(indata.IndexOf("+CREG:") + 6);
                            break;
                    }
                    //labelNetworkStatus.Text = indata.Substring(indata.IndexOf("+CREG:")+6);

                }
                else if (indata.Contains("ERROR") && SimStatusFlag)//وضعیت سیمکارت
                {
                    labelSimStatus.ForeColor = Color.Red;
                    labelSimStatus.Text = "سیمکارت وارد نشده است";
                    SimStatusFlag = false;
                }
            }
            catch
            {

            }
        }
        #endregion

        #region linkLabel1_LinkClicked
        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            ProcessStartInfo sInfo = new ProcessStartInfo("http://www.hadielectronic.com");
            Process.Start(sInfo);
        }
        #endregion

        #region buttonRefreshPorts_Click
        private void buttonRefreshPorts_Click(object sender, EventArgs e)
        {
            comboBoxPortList.Items.Clear();
            foreach (string s in SerialPort.GetPortNames())
            {
                comboBoxPortList.Items.Add(s);
            }
            comboBoxPortList.SelectedIndex = 0;
        }
        #endregion

        #region dataGridViewRecivedSMS_CellDoubleClick
        private void dataGridViewRecivedSMS_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            try
            {
                MessageBox.Show(dataGridViewRecivedSMS.CurrentRow.Cells[2].Value.ToString(), "متن پیامک");
            }
            catch (Exception exp)
            {

            }
        }
        #endregion

        #region timer1_Tick For Update Status
        private void timer1_Tick(object sender, EventArgs e)
        {
            //Sim Status - وضعیت سیمکارت
            labelSimStatus.ForeColor = Color.Green;
            labelSimStatus.Text = "متصل";
            SimStatusFlag = true;
            serialPort1.WriteLine("AT+CIMI");
            Thread.Sleep(150);


            //Anten Status - وضعیت آنتن
            serialPort1.WriteLine("AT+CSQ");
            Thread.Sleep(150);

            //Network Status - وضعیت شبکه
            serialPort1.WriteLine("AT+CREG?");
            Thread.Sleep(150);
        }
        #endregion
    }
}
